
#pragma once

// forwards
class QueryResult;

/*------------------------------------
	DatabaseConnection
------------------------------------*/
class DatabaseConnection
{

public:

	// constructor
	DatabaseConnection( );
	DatabaseConnection( const char* connection_string );

	// destructor
	virtual ~DatabaseConnection( );

	// connect/disconnect
	virtual bool Connect( const char* connection_string );
	virtual void Disconnect( );
	virtual bool IsConnected( );

	// set timeouts
	virtual void SetTimeouts( SQLINTEGER login, SQLINTEGER connection );

	// query
	virtual QueryResult* Execute( const char* sql );
	virtual int ExecuteNoResult( const char* sql );

	// last error
	const char* LastError( );


protected:

	// environment
	SQLHENV environment;

	// connection
	SQLHDBC connection;

	// timeouts
	SQLINTEGER timeout;
	SQLINTEGER timeout_login;

	// last error
	SQLCHAR last_error[ 512 ];

};
