
#pragma once

// forwards
class DatabaseConnection;

/*------------------------------------
	QueryResult
------------------------------------*/
class QueryResult
{

public:

	// constructor
	QueryResult( SQLHSTMT handle );

	// destructor
	~QueryResult( );

	// IsEOF
	bool IsEOF( );

	// moving around the result
	void MoveNext();
	void MovePrevious();
	void MoveFirst();
	void MoveLast();

	// release
	void ReleaseStatement();

	// get data
	bool GetData( SQLUSMALLINT column, SQLSMALLINT type, SQLPOINTER value, SQLLEN length );

	// get column info
	void GetColumnInfo( SQLUSMALLINT column, SQLSMALLINT* type, SQLUINTEGER* length );

	// get column index
	SQLUSMALLINT GetColumnIndex( const char* name );


private:

	// statement handle
	SQLHSTMT statement;

	// eof
	bool eof;

};
